/*
 * Created By Drake Vidkjer
 * Created on 11-14-17
 * Modified on 11-20-17
 * Simple program to display processor cache information
 */
 
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <stdint.h>


int main(int argc, char **argv)
{
	//each entry of array is 8 bits/1byte, so this is easy to decide the number of bytes
	//also want to declare this first so it is the first thing in cache (dont know if this really makes a difference though)
	uint8_t a[1048576];	//array is a fixed size of 10MB, this limits the size of cache it can detect, but not many processors have
	//over 10MB of cache
	
	//create local variables
	clock_t runTime;
	uint32_t step  = 64; //step is 64 bytes beacuse that is a cache line size
	uint32_t numSteps = 1;
	uint8_t dummy = 0;
	uint64_t i = 0;
	double timeTook;
	
	//print out some information about the program
	printf("*******************************************************\n");
	printf("ECE 472 HW3, CPU Cache Information\nCreated by Drake Vidkjer on");
	printf(" 11-14-17\nModified on 11-20-17\nThis program reports");
	printf(" the cache size of the installed processor.");
	printf("\n*****************************************************\n");
	
	//loop through the entire array for different numbers of steps.
	while((numSteps * step) < 1048576)
	{
		//increment the number of steps to run
		numSteps++;
		
		//start the clock
		runTime = clock();
		//loop through the array and touch each element
		for(i = 0; i < (numSteps * step); i = i + step)
		{
			dummy = a[i];
		}
		
		//calc the time it took
		//timeTook = ((double)(clock() - runTime)/CLOCKS_PER_SEC);
		timeTook = ((double)(clock() - runTime));
		timeTook = timeTook/(numSteps * step);
		printf("\nIt took %f time to do one step in traversing %d bytes in the array", timeTook, (numSteps * step));
		
	}	
	printf("\n");
	return 0;
}
